<template>
  <div class="field-container">
    <label class="image" :style="{backgroundImage: `url(${image})`}" :for="`image-input-${id}`">
      <div class="image__placeholder" v-if="!this.image">
        <AddImageIcon class="image__add-icon" />
        <p class="image__text">{{ title }}</p>
      </div>
      <UploadIcon class="image__upload-icon" />
    </label>
    <input :id="`image-input-${id}`" type="file" class="image__input" accept="image/*" @change="onChange" />
  </div>
</template>

<script>
import AddImageIcon from "@/assets/svgs/image.svg";
import UploadIcon from "@/assets/svgs/upload.svg";

export default {
  name: "ImageUploadField",
  components: {
    AddImageIcon,
    UploadIcon
  },
  data() {
    return {
      image: this.value
    }
  },
  props: {
    title: {
      type: String,
      default: ''
    },
    id: {
      type: String,
      required: true 
    },
    maxSize: {
      type: Number,
      default: 3000000
    },
    value: {
      type: String,
      default: ''
    }
  },
  methods: {
    async onChange(e) {
      const file = e.target.files[0];
      if (!file) {
        this.image = '';
        return;
      }
      if (!file.type.startsWith('image')) {
        this.$store.dispatch('notifications/push', {
          type: 'warning',
          light: true,
          message: 'فایل انتخابی نامعتبر است.'
        });
      } else if (file.size > this.maxSize) {
        this.$store.dispatch('notifications/push', {
          type: 'warning',
          light: true,
          message: 'حجم فایل انتخاب شده بیش از 3 مگابایت است.'
        });
      } else {
        this.image = await this.toBase64(file);
        this.$emit('input', this.image, true);
        this.$store.dispatch('notifications/push', {
          type: 'success',
          light: true,
          message: 'فایل با موفقیت انتخاب شد.'
        });
      }
    },
    toBase64: file => new Promise((resolve, reject) => {
        const reader = new FileReader();
        reader.readAsDataURL(file);
        reader.onload = () => resolve(reader.result);
        reader.onerror = error => reject(error);
    }),
    toDataURL: url => fetch(url)
    .then(response => response.blob())
    .then(blob => new Promise((resolve, reject) => {
      const reader = new FileReader()
      reader.onloadend = () => resolve(reader.result)
      reader.onerror = reject
      reader.readAsDataURL(blob)
    }))
  },
  created() {
    if (this.value && !this.value.startsWith('data:image')) {
      this.toDataURL(this.value)
        .then(dataUrl => {
          this.image = dataUrl;
          this.$emit('input', this.image);
        });
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.image
  overflow hidden
  border-radius .5rem
  padding-top 100%
  background-color rgba($grey, .2)
  background-position center
  background-size cover
  display flex
  justify-content center
  align-items center
  opacity 1
  position relative
  z-index 1
  &::after
    content ""
    display block
    position absolute
    top 0
    left 0
    width 100%
    height 100%
    background-color rgba(black, .7)
    opacity 0
    z-index 3
  &:hover
    cursor pointer
    &::after
      opacity 1
  &:hover &__upload-icon
      visibility visible
  &__input
    display none 
  &__upload-icon
    width 10rem
    height 10rem
    position absolute
    top 50%
    left 50%
    transform translate(-50%, -50%)
    fill $white
    z-index 4
    visibility hidden
  &__placeholder
    position absolute
    top 50%
    left 50%
    transform translate(-50%, -50%)
    display flex
    flex-direction column
    align-items center
    justify-content center
    width 100%
  &__text
    color $grey
    opacity .5
  &__add-icon
    width 7.5rem
    height 7.5rem
    fill rgba($grey, .75)
</style>